(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/platform-browser'), require('hammerjs')) :
  typeof define === 'function' && define.amd ? define('ngx-hammerjs-carousel', ['exports', '@angular/core', '@angular/platform-browser', 'hammerjs'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-hammerjs-carousel'] = {}, global.ng.core, global.ng.platformBrowser, global.Hammer));
}(this, (function (exports, i0, platformBrowser, Hammer) { 'use strict';

  function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
      Object.keys(e).forEach(function (k) {
        if (k !== 'default') {
          var d = Object.getOwnPropertyDescriptor(e, k);
          Object.defineProperty(n, k, d.get ? d : {
            enumerable: true,
            get: function () {
              return e[k];
            }
          });
        }
      });
    }
    n['default'] = e;
    return Object.freeze(n);
  }

  var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
  var Hammer__namespace = /*#__PURE__*/_interopNamespace(Hammer);

  var HammerjsCarouselComponent = /** @class */ (function () {
      function HammerjsCarouselComponent(cdRef) {
          this.cdRef = cdRef;
          this.maxNumberOfVisibileInPagination = 15;
          this.activeSlideIndex = 0;
          this.sensitivity = 10;
      }
      Object.defineProperty(HammerjsCarouselComponent.prototype, "slides", {
          get: function () {
              return this.slidesInternal;
          },
          set: function (value) {
              this.slidesInternal = value;
              if (this.slides != null) {
                  this.slideCount = this.slides.length;
              }
              else {
                  this.slideCount = 0;
              }
          },
          enumerable: false,
          configurable: true
      });
      Object.defineProperty(HammerjsCarouselComponent.prototype, "slidesForPagination", {
          get: function () {
              if (this.slides == null) {
                  return null;
              }
              if (this.slides.length > this.maxNumberOfVisibileInPagination) {
                  if (this.activeSlideIndex === this.slides.length - 1) {
                      return this.slides.slice(this.activeSlideIndex - (this.maxNumberOfVisibileInPagination - 1), this.activeSlideIndex + 2);
                  }
                  if (this.activeSlideIndex > this.maxNumberOfVisibileInPagination - 2) {
                      return this.slides.slice(this.activeSlideIndex - (this.maxNumberOfVisibileInPagination - 2), this.activeSlideIndex + 2);
                  }
                  return this.slides.slice(0, this.maxNumberOfVisibileInPagination);
              }
              return this.slides;
          },
          enumerable: false,
          configurable: true
      });
      HammerjsCarouselComponent.prototype.ngOnInit = function () {
          this.isTouchDevice = 'ontouchstart' in window;
      };
      HammerjsCarouselComponent.prototype.ngAfterViewChecked = function () {
          var sliderWrapperElement = this.sliderWrapper.nativeElement;
          this.width = sliderWrapperElement.offsetWidth;
          this.sensitivity = this.width / 40;
          this.cdRef.detectChanges();
      };
      HammerjsCarouselComponent.prototype.onPan = function (e) {
          if (e.velocityX === 0 || Math.abs(e.velocityY) > Math.abs(e.velocityX)) {
              // Vertical scroll
              return;
          }
          var percentage = 100 / this.slideCount * e.deltaX / window.innerWidth;
          var transformPercentage = percentage - 100 / this.slideCount * this.activeSlideIndex;
          this.sliderTransformStyle = 'translateX( ' + transformPercentage + '% )';
          if (e.isFinal) {
              if (e.velocityX > 1) {
                  this.goToSlideIndex(this.activeSlideIndex - 1);
              }
              else if (e.velocityX < -1) {
                  this.goToSlideIndex(this.activeSlideIndex + 1);
              }
              else {
                  if (percentage <= -(this.sensitivity / this.slideCount)) {
                      this.goToSlideIndex(this.activeSlideIndex + 1);
                  }
                  else if (percentage >= (this.sensitivity / this.slideCount)) {
                      this.goToSlideIndex(this.activeSlideIndex - 1);
                  }
                  else {
                      this.goToSlideIndex(this.activeSlideIndex);
                  }
              }
          }
      };
      HammerjsCarouselComponent.prototype.previousSlide = function () {
          var slideIndex = this.activeSlideIndex - 1;
          if (slideIndex < 0) {
              this.goToSlideIndex(this.slideCount - 1);
          }
          else {
              this.goToSlideIndex(slideIndex);
          }
      };
      HammerjsCarouselComponent.prototype.nextSlide = function () {
          var slideIndex = this.activeSlideIndex + 1;
          if (slideIndex === this.slideCount) {
              this.goToSlideIndex(0);
          }
          else {
              this.goToSlideIndex(slideIndex);
          }
      };
      HammerjsCarouselComponent.prototype.goToSlide = function (slide) {
          this.goToSlideIndex(this.slides.indexOf(slide));
      };
      HammerjsCarouselComponent.prototype.goToSlideIndex = function (slideIndex) {
          var _this = this;
          if (slideIndex < 0) {
              this.activeSlideIndex = 0;
          }
          else if (slideIndex > this.slideCount - 1) {
              this.activeSlideIndex = this.slideCount - 1;
          }
          else {
              this.activeSlideIndex = slideIndex;
          }
          this.isAnimating = true;
          var percentage = -(100 / this.slideCount) * this.activeSlideIndex;
          this.sliderTransformStyle = 'translateX(' + percentage + '%)';
          clearTimeout(this.animatingTimeout);
          this.animatingTimeout = setTimeout(function () { return _this.isAnimating = false; }, 400);
      };
      HammerjsCarouselComponent.prototype.isActive = function (slide) {
          return this.slides[this.activeSlideIndex] === slide;
      };
      HammerjsCarouselComponent.prototype.getWidthStyle = function () {
          if (this.width == null) {
              return null;
          }
          return (this.width / 13) + 'px';
      };
      HammerjsCarouselComponent.prototype.getMarginStyle = function () {
          if (this.width == null) {
              return null;
          }
          return (this.width / 30) + 'px';
      };
      return HammerjsCarouselComponent;
  }());
  HammerjsCarouselComponent.decorators = [
      { type: i0.Component, args: [{
                  // tslint:disable-next-line:component-selector
                  selector: 'hammerjs-carousel',
                  template: "\n  <div class=\"slider-wrapper\" #sliderWrapper>\n    <div class=\"slider\" (pan)=\"onPan($event)\" [style.transform]=\"sliderTransformStyle\" [style.width]=\"slideCount + '00%'\"\n         [ngClass]=\"{ 'is-animating': isAnimating }\">\n      <div class=\"slider-panel\" *ngFor=\"let slide of slides\" [style.background-image]=\"'url(' + slide + ')'\"></div>\n    </div>\n    <div class=\"slider-button left\" *ngIf=\"!isTouchDevice && slides?.length > 1\" (click)=\"previousSlide()\">\n        <svg class=\"chevron\" [style.width]=\"getWidthStyle()\" [style.margin-left]=\"getMarginStyle()\"\n        xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"17 15 13 20\" enable-background=\"new 17 15 13 20\" fill=\"#fff\">\n          <path d=\"M27.3 34.7L17.6 25l9.7-9.7 1.4 1.4-8.3 8.3 8.3 8.3z\"/>\n        </svg>\n    </div>\n    <div class=\"slider-button right\" *ngIf=\"!isTouchDevice && slides?.length > 1\" (click)=\"nextSlide()\">\n      <svg class=\"chevron right\" [style.width]=\"getWidthStyle()\" [style.margin-right]=\"getMarginStyle()\"\n      xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"17 15 13 20\" enable-background=\"new 17 15 13 20\" fill=\"#fff\">\n          <path d=\"M27.3 34.7L17.6 25l9.7-9.7 1.4 1.4-8.3 8.3 8.3 8.3z\"/>\n        </svg>\n    </div>\n    <div class=\"slider-pagination\" *ngIf=\"slides?.length > 1\">\n      <div *ngFor=\"let slide of slidesForPagination; index as index;\" (click)=\"goToSlide(slide)\">\n        <div class=\"slider-page\" [ngClass]=\"{ 'is-active': isActive(slide) }\"></div>\n      </div>\n    </div>\n  </div>\n  ",
                  styles: [".slider-wrapper{overflow:hidden;width:100%;height:100%;position:relative}.slider{display:flex;height:100%}.slider.is-animating{transition:transform .4s cubic-bezier(.5,0,.5,1)}.slider-panel{width:100%;background-position:50%;background-repeat:no-repeat;background-size:cover}.slider-button{position:absolute;opacity:.7;height:100%;top:0;width:50%;cursor:pointer}.slider-button:hover{color:#fff;opacity:1}.slider-button.left{left:0}.slider-button.left:hover{background:linear-gradient(270deg,hsla(0,0%,100%,0),hsla(0,0%,100%,.3))}.slider-button.right{right:0}.slider-button.right:hover{background:linear-gradient(90deg,hsla(0,0%,100%,0),hsla(0,0%,100%,.3))}.slider-button .chevron{position:absolute;top:50%;transform:translateY(-50%)}.slider-button .chevron.right{right:0;transform:translateY(-50%) rotate(180deg)}.slider-pagination{bottom:6.25%;left:0;position:absolute;text-align:center;width:100%}.slider-pagination>div{padding:4px;display:inline-block;cursor:pointer}.slider-pagination .slider-page{border-radius:50%;box-shadow:0 0 0 2px hsla(0,0%,100%,.75);height:6px;transition:background-color .25s;width:6px}.slider-pagination .slider-page.is-active{background-color:hsla(0,0%,100%,.75)}"]
              },] }
  ];
  HammerjsCarouselComponent.ctorParameters = function () { return [
      { type: i0.ChangeDetectorRef }
  ]; };
  HammerjsCarouselComponent.propDecorators = {
      slides: [{ type: i0.Input }],
      maxNumberOfVisibileInPagination: [{ type: i0.Input }],
      sliderWrapper: [{ type: i0.ViewChild, args: ['sliderWrapper',] }]
  };

  /*! *****************************************************************************
  Copyright (c) Microsoft Corporation.

  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.

  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */
  /* global Reflect, Promise */
  var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf ||
          ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
          function (d, b) { for (var p in b)
              if (Object.prototype.hasOwnProperty.call(b, p))
                  d[p] = b[p]; };
      return extendStatics(d, b);
  };
  function __extends(d, b) {
      if (typeof b !== "function" && b !== null)
          throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() { this.constructor = d; }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  }
  var __assign = function () {
      __assign = Object.assign || function __assign(t) {
          for (var s, i = 1, n = arguments.length; i < n; i++) {
              s = arguments[i];
              for (var p in s)
                  if (Object.prototype.hasOwnProperty.call(s, p))
                      t[p] = s[p];
          }
          return t;
      };
      return __assign.apply(this, arguments);
  };
  function __rest(s, e) {
      var t = {};
      for (var p in s)
          if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
              t[p] = s[p];
      if (s != null && typeof Object.getOwnPropertySymbols === "function")
          for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
              if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                  t[p[i]] = s[p[i]];
          }
      return t;
  }
  function __decorate(decorators, target, key, desc) {
      var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
      if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
          r = Reflect.decorate(decorators, target, key, desc);
      else
          for (var i = decorators.length - 1; i >= 0; i--)
              if (d = decorators[i])
                  r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
      return c > 3 && r && Object.defineProperty(target, key, r), r;
  }
  function __param(paramIndex, decorator) {
      return function (target, key) { decorator(target, key, paramIndex); };
  }
  function __metadata(metadataKey, metadataValue) {
      if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
          return Reflect.metadata(metadataKey, metadataValue);
  }
  function __awaiter(thisArg, _arguments, P, generator) {
      function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
      return new (P || (P = Promise))(function (resolve, reject) {
          function fulfilled(value) { try {
              step(generator.next(value));
          }
          catch (e) {
              reject(e);
          } }
          function rejected(value) { try {
              step(generator["throw"](value));
          }
          catch (e) {
              reject(e);
          } }
          function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
          step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
  }
  function __generator(thisArg, body) {
      var _ = { label: 0, sent: function () { if (t[0] & 1)
              throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
      return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
      function verb(n) { return function (v) { return step([n, v]); }; }
      function step(op) {
          if (f)
              throw new TypeError("Generator is already executing.");
          while (_)
              try {
                  if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                      return t;
                  if (y = 0, t)
                      op = [op[0] & 2, t.value];
                  switch (op[0]) {
                      case 0:
                      case 1:
                          t = op;
                          break;
                      case 4:
                          _.label++;
                          return { value: op[1], done: false };
                      case 5:
                          _.label++;
                          y = op[1];
                          op = [0];
                          continue;
                      case 7:
                          op = _.ops.pop();
                          _.trys.pop();
                          continue;
                      default:
                          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                              _ = 0;
                              continue;
                          }
                          if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                              _.label = op[1];
                              break;
                          }
                          if (op[0] === 6 && _.label < t[1]) {
                              _.label = t[1];
                              t = op;
                              break;
                          }
                          if (t && _.label < t[2]) {
                              _.label = t[2];
                              _.ops.push(op);
                              break;
                          }
                          if (t[2])
                              _.ops.pop();
                          _.trys.pop();
                          continue;
                  }
                  op = body.call(thisArg, _);
              }
              catch (e) {
                  op = [6, e];
                  y = 0;
              }
              finally {
                  f = t = 0;
              }
          if (op[0] & 5)
              throw op[1];
          return { value: op[0] ? op[1] : void 0, done: true };
      }
  }
  var __createBinding = Object.create ? (function (o, m, k, k2) {
      if (k2 === undefined)
          k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
  }) : (function (o, m, k, k2) {
      if (k2 === undefined)
          k2 = k;
      o[k2] = m[k];
  });
  function __exportStar(m, o) {
      for (var p in m)
          if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
              __createBinding(o, m, p);
  }
  function __values(o) {
      var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
      if (m)
          return m.call(o);
      if (o && typeof o.length === "number")
          return {
              next: function () {
                  if (o && i >= o.length)
                      o = void 0;
                  return { value: o && o[i++], done: !o };
              }
          };
      throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  }
  function __read(o, n) {
      var m = typeof Symbol === "function" && o[Symbol.iterator];
      if (!m)
          return o;
      var i = m.call(o), r, ar = [], e;
      try {
          while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
              ar.push(r.value);
      }
      catch (error) {
          e = { error: error };
      }
      finally {
          try {
              if (r && !r.done && (m = i["return"]))
                  m.call(i);
          }
          finally {
              if (e)
                  throw e.error;
          }
      }
      return ar;
  }
  /** @deprecated */
  function __spread() {
      for (var ar = [], i = 0; i < arguments.length; i++)
          ar = ar.concat(__read(arguments[i]));
      return ar;
  }
  /** @deprecated */
  function __spreadArrays() {
      for (var s = 0, i = 0, il = arguments.length; i < il; i++)
          s += arguments[i].length;
      for (var r = Array(s), k = 0, i = 0; i < il; i++)
          for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
              r[k] = a[j];
      return r;
  }
  function __spreadArray(to, from, pack) {
      if (pack || arguments.length === 2)
          for (var i = 0, l = from.length, ar; i < l; i++) {
              if (ar || !(i in from)) {
                  if (!ar)
                      ar = Array.prototype.slice.call(from, 0, i);
                  ar[i] = from[i];
              }
          }
      return to.concat(ar || from);
  }
  function __await(v) {
      return this instanceof __await ? (this.v = v, this) : new __await(v);
  }
  function __asyncGenerator(thisArg, _arguments, generator) {
      if (!Symbol.asyncIterator)
          throw new TypeError("Symbol.asyncIterator is not defined.");
      var g = generator.apply(thisArg, _arguments || []), i, q = [];
      return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
      function verb(n) { if (g[n])
          i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
      function resume(n, v) { try {
          step(g[n](v));
      }
      catch (e) {
          settle(q[0][3], e);
      } }
      function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
      function fulfill(value) { resume("next", value); }
      function reject(value) { resume("throw", value); }
      function settle(f, v) { if (f(v), q.shift(), q.length)
          resume(q[0][0], q[0][1]); }
  }
  function __asyncDelegator(o) {
      var i, p;
      return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
      function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
  }
  function __asyncValues(o) {
      if (!Symbol.asyncIterator)
          throw new TypeError("Symbol.asyncIterator is not defined.");
      var m = o[Symbol.asyncIterator], i;
      return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
      function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
      function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
  }
  function __makeTemplateObject(cooked, raw) {
      if (Object.defineProperty) {
          Object.defineProperty(cooked, "raw", { value: raw });
      }
      else {
          cooked.raw = raw;
      }
      return cooked;
  }
  ;
  var __setModuleDefault = Object.create ? (function (o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
  }) : function (o, v) {
      o["default"] = v;
  };
  function __importStar(mod) {
      if (mod && mod.__esModule)
          return mod;
      var result = {};
      if (mod != null)
          for (var k in mod)
              if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                  __createBinding(result, mod, k);
      __setModuleDefault(result, mod);
      return result;
  }
  function __importDefault(mod) {
      return (mod && mod.__esModule) ? mod : { default: mod };
  }
  function __classPrivateFieldGet(receiver, state, kind, f) {
      if (kind === "a" && !f)
          throw new TypeError("Private accessor was defined without a getter");
      if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
          throw new TypeError("Cannot read private member from an object whose class did not declare it");
      return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
  }
  function __classPrivateFieldSet(receiver, state, value, kind, f) {
      if (kind === "m")
          throw new TypeError("Private method is not writable");
      if (kind === "a" && !f)
          throw new TypeError("Private accessor was defined without a setter");
      if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
          throw new TypeError("Cannot write private member to an object whose class did not declare it");
      return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
  }

  var GestureConfigService = /** @class */ (function (_super) {
      __extends(GestureConfigService, _super);
      function GestureConfigService() {
          return _super !== null && _super.apply(this, arguments) || this;
      }
      GestureConfigService.prototype.buildHammer = function (element) {
          var mc = new Hammer__namespace(element, {
              touchAction: 'pan-y',
              recognizers: [
                  [Hammer__namespace.Pan],
              ]
          });
          return mc;
      };
      return GestureConfigService;
  }(platformBrowser.HammerGestureConfig));
  GestureConfigService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function GestureConfigService_Factory() { return new GestureConfigService(); }, token: GestureConfigService, providedIn: "root" });
  GestureConfigService.decorators = [
      { type: i0.Injectable, args: [{
                  providedIn: 'root'
              },] }
  ];

  var HammerjsCarouselModule = /** @class */ (function () {
      function HammerjsCarouselModule() {
      }
      return HammerjsCarouselModule;
  }());
  HammerjsCarouselModule.decorators = [
      { type: i0.NgModule, args: [{
                  declarations: [HammerjsCarouselComponent],
                  imports: [
                      platformBrowser.BrowserModule, platformBrowser.HammerModule
                  ],
                  exports: [HammerjsCarouselComponent],
                  providers: [{
                          provide: platformBrowser.HAMMER_GESTURE_CONFIG,
                          useClass: GestureConfigService
                      }]
              },] }
  ];

  /*
   * Public API Surface of ngx-hammerjs-carousel
   */

  /**
   * Generated bundle index. Do not edit.
   */

  exports.HammerjsCarouselComponent = HammerjsCarouselComponent;
  exports.HammerjsCarouselModule = HammerjsCarouselModule;
  exports.ɵa = GestureConfigService;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-hammerjs-carousel.umd.js.map
